{ Small test project to compare pthreads unit usage between FreeBSD and Linux }
program project1;

{$mode objfpc}{$H+}

uses
  classes
  ,sysutils
  ,pthreads
  ,baseunix
  ;

var
  Result: boolean;
  c: integer;
  FSemaphore: TSemaphore;
  FMinPoolSize: Word;
  FMaxPoolSize: DWord;


procedure CreatePoolSemaphore;
begin
  FillChar(FSemaphore, sizeof(FSemaphore), 0);
  // pShared = 0 means, shared between the threads of a process
  Writeln('FMaxPoolSize before = ', FMaxPoolSize);
  if sem_init(FSemaphore, 0, FMaxPoolSize) <> 0 then
    raise Exception.Create('Failed to initialize the semaphore');
  writeln('FMaxPoolSize after = ', FMaxPoolSize);
end;

procedure DestroyPoolSemaphore;
var
  error: integer;
  i: integer;
begin
  i := 0;
  sem_getvalue(FSemaphore, i);
  writeln('i = ', i);
  while i < FMaxPoolSize do
  begin
    writeln('unlock a semaphore');
    if sem_post(FSemaphore) <> 0 then // unlock a semaphore
      raise Exception.Create('received an error trying to unlock semaphore');
    sem_getvalue(FSemaphore, i);
    writeln('i = ', i);
  end;
  error := sem_destroy(FSemaphore);
  if error <> 0 then
    raise Exception.Create('Failed to destroy the semaphore');
end;

begin
  FMinPoolSize := 0;
  FMaxPoolSize := 2;

  CreatePoolSemaphore;
  c := 0;
  sem_getvalue(FSemaphore, c);
  writeln('c = ', c);

  writeln('Now create a lock');
  sem_trywait(FSemaphore);
  sem_getvalue(FSemaphore, c);
  writeln('c = ', c);

  writeln('Now create a lock');
  repeat
    Result := sem_trywait(FSemaphore) = 0;
  until Result or (GetLastOSError <> ESysEINTR);  // ESysEINTR = System error: Interrupted system call
  sem_getvalue(FSemaphore, c);
  writeln('c = ', c);

  DestroyPoolSemaphore;

end.

